package com.eactive.eai.batch.job.jobItem.lgcns;

import java.io.ByteArrayOutputStream;
import java.util.ArrayList;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.CommonKeys;
import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.osd.OutsideManager;
import com.eactive.eai.batch.osd.OutsideVO;
import com.eactive.eai.batch.rule.dirInfo.BatchJobInfoVO;
import com.eactive.eai.batch.rule.dirInfo.DirInfoManager;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_LGCNS_0640 extends DefaultTelegram implements TelegramService
{
    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

//    private Properties telegramInfo;
    /**
     * 생성자
     */
    public SEND_LGCNS_0640() {
        //화일정보수신통보
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            boolean result = calculateSendLength();
            if (!result) return false;

            //전송길이
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //트랜잭션코드 -- 사용하지 않음
            compileField(1, "", this.al_FieldProps[1]);

            //업무구분코드 - “CMS”
            compileField(2, "CMS", this.al_FieldProps[2]);

            //기관코드 “71”
            compileField(3, "71", this.al_FieldProps[3]);

            //전문종별코드. 전문의 기능을 나타냄.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);

            //거래구분코드 S/R :  서버송신 : S 서버수신: R
            String procType = batchDoc.getBatchMsg().getHeader().getProcessType();
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND)) {
                compileField(5, "R", this.al_FieldProps[5]);
            }else{
                compileField(5, "S", this.al_FieldProps[5]);
            }

            //송수신 FLAG B/C    B:Bank, C:Center
            compileField(6, "B", this.al_FieldProps[6]);

            //화일명
            compileField(7, batchDoc.getBatchMsg().getHeader().getFileName() , this.al_FieldProps[7]);
            //응답코드
            compileField(8, this.getSendResponseCode(), this.al_FieldProps[8]);
            //화일 정보내역. 화일명+화일size+전문바이트수
            //RECV 0630/0640에서는 서로 교환한 값중 작은 값으로 결정한다.
            StringBuffer fileInfo = new StringBuffer();
            fileInfo.append(makeSpace(batchDoc.getBatchMsg().getHeader().getFileName(), 8));
            fileInfo.append(makeZero(""+batchDoc.getBatchMsg().getBody().getCurFileSize(),12));
            fileInfo.append(makeZero(""+calculateTelegramSize(), 4));
            compileField(9, fileInfo.toString(), this.al_FieldProps[9]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
//            telegramInfo = getTelegramInfo();
            //해당 거래구분에 대한 Job_Code 값 설정
            //거래구분코드 조회 BizCode 조회
            int bizCodeStartIndex = 0;
            int bizCodeEndIndex   = 0;
            String fileName = batchDoc.getBatchMsg().getHeader().getFileName();
            ArrayList<OutsideVO> organList = OutsideManager.getInstance().getOutsideInfo(batchDoc.getBatchMsg().getHeader().getProcessCode());
            for (int i=0; organList!=null && i<organList.size(); i++) {
              OutsideVO organInfo = organList.get(i);
              if ( batchDoc.getBatchMsg().getHeader().getInstitutionCode().equals(organInfo.getOsdCode()) ) {
                bizCodeStartIndex = organInfo.getBizCdStartIdx();
                bizCodeEndIndex   = organInfo.getBizCdEndIdx();
                break;
              }
            }
            if (bizCodeStartIndex <= 0 || bizCodeStartIndex >= fileName.length()) bizCodeStartIndex = 0;
            if (bizCodeEndIndex   <= 0 || bizCodeEndIndex   >  fileName.length()) bizCodeEndIndex = fileName.length();
            String bizCode = fileName.substring(bizCodeStartIndex, bizCodeEndIndex);

            BatchJobInfoVO info = DirInfoManager.getInstance().getFileInfoByDstcd(batchDoc.getBatchMsg().getHeader().getProcessCode(), bizCode);
            if (info != null) {
                batchDoc.getBatchMsg().getHeader().setJobCode(info.getMsgDstCode());;
            } else {
            	logger.debug("{} " + batchDoc.getBatchMsg().getHeader().getUUID()+ "'s Job Code is null", logHeader);
                String processCode = batchDoc.getBatchMsg().getHeader().getProcessCode();
                batchDoc.getBatchMsg().getHeader().setJobCode((processCode+"00000"));   //dummy code
                // TEST 용 return false;
            }
//            try {
//				int sleepTime = Integer.parseInt(telegramInfo.getProperty(TelegramKeys.SLEEP_TIME));
//				Thread.sleep(sleepTime); 
//			} catch (Exception e) {}
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<9; i++) { //CMS전문의 헤더는 응답코드까지 임.
                byte[] barr = (byte[])this.al_Field.get(i);
                if ( barr[0] != '\0') {
                    baout.write((byte[])this.al_Field.get(i));
                }
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=9; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            //성공 시 응답수신 파일 Start DB로그
            if (this.getSendResponseCode().equals(TelegramKeys.RES_CODE_SUCESS)){
                LogUtil.setLogFileStart(batchDoc);
            }

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            // XX인 경우 길이를 1로 계산하므로 i=3 인 경우 실제 기관 코드 사용 길이-1 만큼을 더 해 준다.
            for (int i=1; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    private int calculateTelegramSize(){
        int recSize = 200;
        String bizCode = batchDoc.getBatchMsg().getHeader().getBizCode();
        String processCode = batchDoc.getBatchMsg().getHeader().getProcessCode();
        BatchJobInfoVO bJobInfo = DirInfoManager.getInstance().getFileInfoByDstcd(processCode, bizCode);
        if ( bJobInfo != null && bJobInfo.getFileRecSize() > 0 ){
            recSize = (int)Math.min(bJobInfo.getFileRecSize(), 4000);
        }

        // 0630/0640 전문 길이 ( 공통 + 24  = SEND_LENGTH ) 0320 전문 길이 ( 공통 + 11 + 파일내역  )
        // 그러므로 0320 전문의 길이는 0630/0640 전문 길이에서 파일 내역을 더하고 13을 빼 준다 )
        return (batchDoc.getBatchMsg().getHeader().getSequenceSize() / recSize) * recSize + SEND_LENGTH - 13;
    }
    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(5);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(8);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}